searchNodes=[{"doc":"Main module of IdenticonSvg that contains all functions of the library.","ref":"IdenticonSvg.html","title":"IdenticonSvg","type":"module"},{"doc":"","ref":"IdenticonSvg.html#convert_polygons_into_edgelists/1","title":"IdenticonSvg.convert_polygons_into_edgelists/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#extract_colors/1","title":"IdenticonSvg.extract_colors/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#extract_foreground_squares/1","title":"IdenticonSvg.extract_foreground_squares/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#find_neighboring_squares/1","title":"IdenticonSvg.find_neighboring_squares/1","type":"function"},{"doc":"Generate the SVG code of the identicon for the specified text . Without specifying any optional arguments this function generates a 5x5 identicon with a transparent background and colored grid squares with full opacity. A different hashing function is used automatically for each identicon size , so that the utilization of bits is maximized for the given size: MD5 for sizes 4 and 5, RIPEMD-160 for 6, and SHA3 for 7 to 10 with 224, 256, 384 and 512 bits, respectively. Optionally, specify any combination of the following arguments: size : the number of grid squares of the identicon's side; integer, 4 to 10; 5 by default. bg_color : the color of the background grid squares as a hex code string (e.g., #eee ) or an atom specifying the color complementarity (se below); nil by default. opacity : the opacity of the entire identicon (all grid squares); float, 0.0 to 1.0; 1.0 by default. The color of the foreground grid squares is always equal to the three first bytes of the hash of text , regardless of which hashing function is used automatically. Setting bg_color to nil (default value) generates only the foreground (colored) squares, with the default (1.0) or requested opacity . New since v0.9.0: Setting padding to a positive integer sets the padding to the identicon to that value. If bg_color is non-nil, it will also be applied to the padding area with the with the default (1.0) or requested opacity , which is applied the same on the foreground and the background. The file size is greatly reduced. New since v0.8.0: Setting bg_color to one of the following 3 atom values sets the color of the background squares to the corresponding RGB-complementary color of the automatically-defined foreground color, with the default (1.0) or requested opacity : :basic : the complementary color, i.e. the opposite color of fg_color on the color wheel. :split1 : the first adjacent tertiary color of the complement of fg_color on the color wheel. :split2 : the second adjacent tertiary color of the complement of fg_color on the color wheel. Examples 5x5 identicon with transparent background: generate ( &quot;banana&quot; ) 5x5 identicon with complementary background color: generate ( &quot;banana&quot; , 5 , :basic ) 5x5 identicon with first split-complementary background color: generate ( &quot;banana&quot; , 5 , :split1 ) 5x5 identicon with second split-complementary background color: generate ( &quot;banana&quot; , 5 , :split2 ) 6x6 identicon with transparent background: generate ( &quot;pineapple&quot; , 6 ) 7x7 identicon with padding 1, complementary background color, and 70% opacity: generate ( &quot;overbring.com&quot; , 7 , :basic , 0.7 , 1 ) 7x7 identicon with blue ( #33f ) background: generate ( &quot;refrigerator&quot; , 7 , &quot;#33f&quot; ) 9x9 identicon with transparent background and 50% opacity: generate ( &quot;2023-03-14&quot; , 9 , nil , 0.5 ) 10x10 identicon with yellow ( #ff0 ) background and 80% opacity: generate ( &quot;banana&quot; , 10 , &quot;#ff0&quot; , 0.8 )","ref":"IdenticonSvg.html#generate/5","title":"IdenticonSvg.generate/5","type":"function"},{"doc":"","ref":"IdenticonSvg.html#generate_coordinates/1","title":"IdenticonSvg.generate_coordinates/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#generate_svg/1","title":"IdenticonSvg.generate_svg/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#group_neighbors_into_polygons/1","title":"IdenticonSvg.group_neighbors_into_polygons/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#hash_input/1","title":"IdenticonSvg.hash_input/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#keys_by_value/2","title":"IdenticonSvg.keys_by_value/2","type":"function"},{"doc":"","ref":"IdenticonSvg.html#return_svg/1","title":"IdenticonSvg.return_svg/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#square_grid/1","title":"IdenticonSvg.square_grid/1","type":"function"},{"doc":"","ref":"IdenticonSvg.html#trace_polygon_edges_to_paths/1","title":"IdenticonSvg.trace_polygon_edges_to_paths/1","type":"function"},{"doc":"Module of IdenticonSvg that contains functions related to handling colors.","ref":"IdenticonSvg.Color.html","title":"IdenticonSvg.Color","type":"module"},{"doc":"Take an list of integers representing the red, green, and blue components of a color as integers in the range 0..255, and return a complementary color based on the provided value of the :compl keyword option.","ref":"IdenticonSvg.Color.html#color_wheel/2","title":"IdenticonSvg.Color.color_wheel/2","type":"function"},{"doc":"Convert a hexadecimal color string with 3 characters, with or without a # prefix, to a hexadecimal color string with 6 uppercase characters. If the input hex color has 6 characters, return it untouched. Otherwise, raise an ArgumentError .","ref":"IdenticonSvg.Color.html#hex_to_hex6/1","title":"IdenticonSvg.Color.hex_to_hex6/1","type":"function"},{"doc":"Convert a hexadecimal color string with 3 or 6 characters, with or without a # prefix, to a list of integers representing the red, green, and blue components of a color as integers in the range 0..255","ref":"IdenticonSvg.Color.html#hex_to_rgb/1","title":"IdenticonSvg.Color.hex_to_rgb/1","type":"function"},{"doc":"Convert an integer in the range 0..255 to a zero-padded hexacedimal string","ref":"IdenticonSvg.Color.html#integer_to_hex/1","title":"IdenticonSvg.Color.integer_to_hex/1","type":"function"},{"doc":"Convert a list of integers representing the red, green, and blue components of a color as integers in the range 0..255 to a hexadecimal color string with 6 characters, prefixed by &quot;#&quot;","ref":"IdenticonSvg.Color.html#rgb_to_hex6/1","title":"IdenticonSvg.Color.rgb_to_hex6/1","type":"function"},{"doc":"Module of IdenticonSvg that contains functions related to drawing SVG elements and composing the SVG output of the requested identicon.","ref":"IdenticonSvg.Draw.html","title":"IdenticonSvg.Draw","type":"module"},{"doc":"Compose the SVG content out of the templates and return a string. Arguments (all mandatory): paths : the :paths field of the %Identicon{} struct, i.e. single-height polygon &quot;strips&quot; across the mirroring axis after neighbor detection. size : the size of the identicon without padding. padding : the requested padding (positive or zero integer). fg_color and bg_color : foreground and background color hex strings. opacity : requested opacity (0.0 to 1.0).","ref":"IdenticonSvg.Draw.html#svg/6","title":"IdenticonSvg.Draw.svg/6","type":"function"},{"doc":"Module incorporating functions that remove internal edges shared between squares grouped into a polygon.","ref":"IdenticonSvg.EdgeCleaner.html","title":"IdenticonSvg.EdgeCleaner","type":"module"},{"doc":"Identify the external edges of a polygon.","ref":"IdenticonSvg.EdgeCleaner.html#polygon_external_edges/2","title":"IdenticonSvg.EdgeCleaner.polygon_external_edges/2","type":"function"},{"doc":"Module that contains functions for tracing edges around merged squares of the identicon's grid.","ref":"IdenticonSvg.EdgeTracer.html","title":"IdenticonSvg.EdgeTracer","type":"module"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#connect_edges/1","title":"IdenticonSvg.EdgeTracer.connect_edges/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#direct/2","title":"IdenticonSvg.EdgeTracer.direct/2","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#doit/1","title":"IdenticonSvg.EdgeTracer.doit/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#doit_one/1","title":"IdenticonSvg.EdgeTracer.doit_one/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#edge_connector/1","title":"IdenticonSvg.EdgeTracer.edge_connector/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#edge_neighbors_by_midpoint/1","title":"IdenticonSvg.EdgeTracer.edge_neighbors_by_midpoint/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#edge_orientation_by_midpoint/1","title":"IdenticonSvg.EdgeTracer.edge_orientation_by_midpoint/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#midpoint/1","title":"IdenticonSvg.EdgeTracer.midpoint/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#midpoint_to_unoriented_edge/1","title":"IdenticonSvg.EdgeTracer.midpoint_to_unoriented_edge/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#orientation/1","title":"IdenticonSvg.EdgeTracer.orientation/1","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#point_plus_vector/2","title":"IdenticonSvg.EdgeTracer.point_plus_vector/2","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#same_orientation?/2","title":"IdenticonSvg.EdgeTracer.same_orientation?/2","type":"function"},{"doc":"","ref":"IdenticonSvg.EdgeTracer.html#trace_edges/1","title":"IdenticonSvg.EdgeTracer.trace_edges/1","type":"function"},{"doc":"Defines the %Identicon{} struct used by the functions of the main module to gradually process and generate an identicon.","ref":"IdenticonSvg.Identicon.html","title":"IdenticonSvg.Identicon","type":"module"},{"doc":"Module incorporating functions that find neighboring squares and use Enum.reduce/3 to group them into polygons.","ref":"IdenticonSvg.PolygonReducer.html","title":"IdenticonSvg.PolygonReducer","type":"module"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#col_row_neighbors/2","title":"IdenticonSvg.PolygonReducer.col_row_neighbors/2","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#col_row_to_index/2","title":"IdenticonSvg.PolygonReducer.col_row_to_index/2","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#disjoint?/2","title":"IdenticonSvg.PolygonReducer.disjoint?/2","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#group/1","title":"IdenticonSvg.PolygonReducer.group/1","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#group_into_polygons/1","title":"IdenticonSvg.PolygonReducer.group_into_polygons/1","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#index_neighbors/2","title":"IdenticonSvg.PolygonReducer.index_neighbors/2","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#index_to_col_row/2","title":"IdenticonSvg.PolygonReducer.index_to_col_row/2","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#neighbors_per_index/2","title":"IdenticonSvg.PolygonReducer.neighbors_per_index/2","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#reducer/2","title":"IdenticonSvg.PolygonReducer.reducer/2","type":"function"},{"doc":"","ref":"IdenticonSvg.PolygonReducer.html#within_bounds/2","title":"IdenticonSvg.PolygonReducer.within_bounds/2","type":"function"},{"doc":"IdenticonSvg An Elixir library to generate identicons in SVG format, so they can be inlined in HTML.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Github-style square identicon sizes from 4x4 to 10x10. The hashing function is automatically chosen based on the requested size. The foreground color choice is automatic based on the hash. Optional (integer) padding. Optional background color, manually defined or automatically set as basic or split complementary. Transparent background (also on the padding) if no background color specified. Optionally non-100% opacity. Small SVG file size makes it great for inlining in HTML. No external dependencies.","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"The package is available in Hex and can be installed by adding identicon_svg to your list of dependencies in mix.exs : def deps do [ { :identicon_svg , &quot;~&gt; 0.9.0&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"New since v0.9.0 Setting padding to a positive integer sets the padding to the identicon to that value. If bg_color is non-nil, it will also be applied to the padding area with the with the default (1.0) or requested opacity , which is also applied on the foreground and the background. The size of the generated SVG code is greatly reduced. New since v0.8.0 Setting bg_color to one of the following 3 atom values sets the color of the background squares to the corresponding RGB-complementary color of the automatically-defined foreground color, with the default (1.0) or requested opacity : :basic : the complementary color, i.e. the opposite color of fg_color on the color wheel. :split1 : the first adjacent tertiary color of the complement of fg_color on the color wheel. :split2 : the second adjacent tertiary color of the complement of fg_color on the color wheel.","ref":"readme.html#recent-changes","title":"README - Recent changes","type":"extras"},{"doc":"No configuration required.","ref":"readme.html#configuration","title":"README - Configuration","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/identicon_svg . There's also a discussion thread on elixirforum.com .","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"[x] Implement core functionality [x] Publish on hex.pm [x] Add background color functionality (split-complementary for automatic color-matching) [x] Add padding [x] Reduce generated SVG file size [ ] Implement testing functions [ ] Set up CI","ref":"readme.html#todo-maybe-one-day","title":"README - TODO (maybe, one day)","type":"extras"}]